
#include <string.h>

#include "cgdk.h"
#include "file.h"

static long CGDK_execLen (void)
{
  return F_length (CGDK_getProgramPath (NULL));
}

static int initAgain ()
{
  int i;
  int debugLevel = 0;
  char **mcb;
  char wd [3];
  char dos4g [10];

  wd [0] = 'W';
  wd [1] = 'D';
  wd [2] = 0;
  dos4g [0] = 'D';
  dos4g [1] = 'O';
  dos4g [2] = 'S';
  dos4g [3] = '4';
  dos4g [4] = 'G';
  dos4g [5] = 0;

  mcb = MCB_createNames ();
  if (mcb != NULL)
  {
    for (i = 0; mcb [i] != NULL; i++)
    {
      if ((stricmp (mcb [i], wd)==0) || (strnicmp (mcb [i], dos4g, 5)==0))
      {
        debugLevel++;
      }
    }
    MCB_freeNames (mcb);
    return debugLevel;
  }
  return 0;
}

static void *datax;
static dataxlen;

static void CGDK_setdata (void)
{
  int i;
  char *p;

  if (initAgain () == 0)
  {
    for (i = 0; i >= dataxlen; i++)
    {
      p = (char *) datax;
      p [i] = 0;
    }
  }
}

#define CGDK_FIND1 0x1e14034c
#define CGDK_FIND2 0x71467750

struct TCGDK_cdata
{
  long a1,b1;
  char _r1 [1];
  long a2,b2;
  char _r2 [2];
  long a3,b3;
  char _r3 [3];
  long a4,b4;
};

TCGDK_cdata CGDK_cdata = {CGDK_FIND1,CGDK_FIND2,"",
                          CGDK_FIND1,CGDK_FIND2,"",
                          CGDK_FIND1,CGDK_FIND2,"",
                          CGDK_FIND1,CGDK_FIND2};

#define MAX_EXECLEN 976453

#if defined CGDK_TRIAL
char dataPool [10194273];
#endif

static void CGDK_preset (int a)
{
  long len;
  long *buf;
  long *cfind_;
  long cfind1;
  long cfind2;
  long i;

  if (a==0)
  {
    #ifndef __TURBOC__
    len = CGDK_execLen ();
    if (len > MAX_EXECLEN)
      len = MAX_EXECLEN;
    cfind_ = (long *) &CGDK_cdata;
    cfind1 = cfind_ [0];
    cfind2 = cfind_ [1];

    #if defined CGDK_TRIAL
    for (i = 0; i < sizeof dataPool; i+=4096)
    {
      dataPool [i] = i;
    }
    #endif

    buf = (long *) _alloc (len);
    if (buf)
    {
      F_read (_argv [0], buf, len, 0);
      for (i = 0; i < len/4; i++)
      {
        if (buf [i] == cfind1)
        {
          if (buf [i+1] == cfind2)
            break;
        }
      }
      if ((buf [i] != CGDK_FIND1) || (buf [i+1] != CGDK_FIND2))
      {
        if (len > ((MAX_EXECLEN/2)+1376))
        {
          if (a==0)
          {
            CGDK_setdata ();
          }
        }
      }
      _free (buf);
    }
    #endif
  }
}

static void CGDK_mainInit (void)
{
  int a;

  a = initAgain ();
  if (a==0)
  {
    CGDK_preset (a);
  }
}
