
#include <stdio.h>

#define CODE_BUF_EMPTY -1


int inBuf = CODE_BUF_EMPTY;
int outBuf = CODE_BUF_EMPTY;

inline int LZW_getCode (int (*getChar) (void), long &bytesRead)
{
  int localBuf, result;

  if (inBuf == CODE_BUF_EMPTY)
  {
    localBuf = getChar ();
    if (localBuf == EOF)
    {
      result = EOF;
    }
    else
    {
      bytesRead++;
//      localBuf &= 0xFF;
      inBuf = getChar ();
      if (inBuf == EOF)
      {
	result = EOF;
      }
      else
      {
	bytesRead++;
//	inBuf &= 0xFF;
	result = ((localBuf << 4) & 0xFF0) + ((inBuf >> 4) & 0x00F);
	inBuf &= 0x000F;
      }
    }
  }
  else
  {
    localBuf = getChar ();
    if (localBuf == EOF)
    {
      result = EOF;
    }
    else
    {
      bytesRead++;
  //    localBuf &= 0xFF;
      result = localBuf + ((inBuf << 8) & 0xF00);
      inBuf = CODE_BUF_EMPTY;
    }
  }

  return result;
}

inline void LZW_putCode (int code, int (*putChar) (int), long &bytesWritten)
{
  if (outBuf == CODE_BUF_EMPTY)
  {
    putChar ( (code >> 4) & 0xFF);
    bytesWritten++;
    outBuf = code & 0x000F;
  }
  else
  {
    putChar (( ((outBuf << 4) & 0xFF0) + ((code >> 8) & 0x00F) ) );
    bytesWritten++;
    putChar ( (code & 0x00FF));
    bytesWritten++;
    outBuf = CODE_BUF_EMPTY;
  }
}

inline void LZW_putCodeEnd (int (*putChar) (int), long &bytesWritten)
{
  if (outBuf != CODE_BUF_EMPTY)
  {
    putChar ((outBuf << 4) & 0xFF0);
    bytesWritten++;
  }
}
