

#include <dos.h>
#include <string.h>
#include <stdio.h>
#include <stdlib.h>
#include <mem.h>

#include "timer.h"
#include "keyb.h"
#include "file.h"
#include "dig.h"
#include "mouse.h"
#include "svga.h"
#include "csf.h"
#include "keyb.h"
#include "win.h"
#include "tm.h"
#include "cgdk.h"
#include "joy.h"
#include "car.h"
#include "pal.h"

typedef struct
{
  int left;
  int right;
  int up;
  int down;
  int inv;
  int use;
  int map;
  int fire;
  int strafe;
  int s_left;
  int s_right;
  int n_vision;
  int next_p;
  int next_w;
  int weapon_1;
  int weapon_2;
  int weapon_3;
  int weapon_4;
} Tk_def;

typedef struct
{
  int brightness;
  int vol_sound;
  int vol_cd;
  int s_reverse;
  Tk_def k_def;
} Toptions;

Toptions options;

static void defaultKeys (void)
{
  options.k_def.left = KEY_LEFT;
  options.k_def.right = KEY_RIGHT;
  options.k_def.up = KEY_UP;
  options.k_def.down = KEY_DOWN;
  options.k_def.inv = KEY_ENTER;
  options.k_def.use = KEY_SPACE;
  options.k_def.map = KEY_BACKSPACE;
  options.k_def.fire = KEY_RCTRL;
  options.k_def.strafe = KEY_RALT;
  options.k_def.s_left = KEY_PERIOD;
  options.k_def.s_right = KEY_COMMA;
  options.k_def.next_p = KEY_RSHIFT;
  options.k_def.next_w = KEY_SLASH;
  options.k_def.n_vision = KEY_N;
  options.k_def.weapon_1 = KEY_1;
  options.k_def.weapon_2 = KEY_2;
  options.k_def.weapon_3 = KEY_3;
  options.k_def.weapon_4 = KEY_4;
}

#define SAVEGAME_CATALOG "savegame.cat"
#define CONFIG_FILENAME "config.cfg"

#define CSF_FONT0 "scifi.csf"
#define CSF_DESKTOP "desktop.csf"
#define CSF_MOUSECURSOR "mouse.csf"
#define CSF_CURSOR "cursor.csf"

#define SAVEEXT "sav"
#define SAVENAME "main"

#define EMPTYSLOT 0
#define NONE -1
#define CANCEL 0
#define OK 1
#define YES 2
#define NO 3
#define CHANGE 4

#define NEWGAME 11
#define LOADGAME 12
#define MULTIPLAYER 13
#define INTRODUCTION 14
#define EXITGAME 15
#define OPTIONS 16

#define LOAD 121
#define DELETE 122
#define SAVE 123

#define NETWORKGAME 131
#define SERIALGAME 132

#define CONTROLS 161
#define DEFAULTS 162

#define KEYBOARD 1161
#define JOYSTICK 1162

#define C_CONTENT LIGHTBLUE //+ B_BLUE
#define C_SELECT LIGHTBLUE + B_CYAN
#define C_BUTTON LIGHTBLUE + B_BLUE
#define C_BSELECT CYAN + B_BLUE
#define C_BPUSH LIGHTCYAN + B_BLUE


static TWIN *MyDesktop;
static TWIN *WinMultiplayer;
static TWIN *WinMain;
static TWIN *WinOptions;
static TWIN *WinControls;
static TWIN *WinLoad;
static TWIN *WinSave;
static TWIN *WinSaveDesc;
static TWIN *WinDelete;
static TWIN *WinPickSaveFile;
static TWIN *WinPickLoadFile;
static TWIN *WinLoadButton;
static TWIN *WinSaveButton;
static TWIN *WinCancelButton;
static TWIN *WinConfirm;
static TWIN *WinMessage;
static TWIN *WinSetupKeys;
static TWIN *WinPickKey;
static TWIN *WinPressKey;
static TWIN *WinCalibrateJoy;

#define CSF_TILENAME "main"

#define TILE_DESKTOP 0
#define TILE_BUTTON 5
#define TILE_LOAD 2
#define TILE_LOADPICK 9
#define TILE_CONFIRM 4
#define TILE_MESSAGE 4
#define TILE_SAVE 2
#define TILE_SAVEPICK 5
#define TILE_MAIN 1
#define TILE_OPTIONS 1
#define TILE_MULTIPLAYER 9
#define TILE_CONTROLS 2
#define TILE_SETUPKEYS 3
#define TILE_PICKKEY 3
#define TILE_PRESSKEY 4
#define TILE_CALIBRATEJOY 4

static TCSF *tile [10];

static void calibrateJoy (void)
{
  int breakIt;

//  JOY_init ();

  if (JOY_state.a.installed == JOY_DETECTED)
  {
    while (JOY_state.a.button1)
    {
      JOY_read ();
      WIN_waitHandler ();
    }
    breakIt = 0;
    strcpy (WinCalibrateJoy->content [1].item, " Move joystick to the upper left corner");
    strcpy (WinCalibrateJoy->content [2].item, " and press button 1");
    WIN_open (WinCalibrateJoy);
    WIN_redrawScreen ();
    do
    {
      JOY_moveUpperLeftA ();
      if (KEYB_get() == KEY_ESC)
      {
        breakIt = 1;
        break;
      }
    }
    while (JOY_state.a.button1 != JOY_BUTTONPRESSED);

    if (!breakIt)
    {
      while (JOY_state.a.button1)
      {
        JOY_read ();
        if (WIN_waitHandler ())
          breakIt = 1;
      }
      strcpy (WinCalibrateJoy->content [1].item, " Move joystick to the lower right corner");
      strcpy (WinCalibrateJoy->content [2].item, " and press button 1");
      WIN_printContent (WinCalibrateJoy, 0);
      WIN_redrawScreen ();
      do
      {
        JOY_moveLowerRightA ();
        if (KEYB_get () == KEY_ESC)
        {
          breakIt = 1;
          break;
        }
      }
      while (JOY_state.a.button1 != JOY_BUTTONPRESSED);
    }

    if (!breakIt)
    {
      while (JOY_state.a.button1)
      {
        JOY_read ();
        WIN_waitHandler ();
        if (WIN_waitHandler ())
          breakIt = 1;
      }
    }
    WIN_close (WinCalibrateJoy);
  }
}

static int confirm (char *str)
{
  int exitCode = NONE;
  int com;

  strcpy (WinConfirm->content [1].item, str);
  do
  {
    com = WIN_exec (WinConfirm);
    if (com == WIN_COM_ESC)
      exitCode = NO;
    else
    {
      exitCode = WIN_value (WIN_subWin (WinConfirm));
    }
  }
  while (exitCode == NONE);

  return exitCode;
}

static void message (char *str)
{
  strcpy (WinMessage->content [1].item,str);
  WIN_exec (WinMessage);
}

static void loadCat (TWIN *win)
{
  FILE *f;
  int i,j,count,value;
  char fBuf [ITEM_SIZE];
  char s [ITEM_SIZE];

  f = fopen (SAVEGAME_CATALOG,"rt");
  if (f != NULL)
  {
    for (i = 0; i < win->contentMax; i++)
    {
      if (fgets (fBuf, ITEM_SIZE-1, f) == NULL)
      {
        break;
      }
      count = 0;
      for (j = 0; j < strlen (fBuf); j++)
      {
        if (fBuf [j] == ' ')
        {
          if (count)
            fBuf [j] = 0xFF;
          count++;
        }
      }
      sscanf (fBuf, "%i%s",&value,s);

      for (j = 0; j < strlen (s); j++)
      {
        if ((unsigned char)s [j] == 0xFF)
          s [j] = ' ';
      }

      strcat (s, "\n");
      WIN_appendList (win, "", s, value, NULL, -1);
    }

    fclose (f);
  }
}

static void saveCat (TWIN *win)
{
  FILE *f;
  int i;

  f = fopen (SAVEGAME_CATALOG,"wt");
  if (f != NULL)
  {
    for (i = 0; i < win->contentCount; i++)
    {
      if (win->content [i].value != EMPTYSLOT)
      {
        fprintf (f, "%i %s", win->content [i].value,
                             win->content [i].item);
      }
    }
    fclose (f);
  }
}

static void getSaveFileName (char *s, int saveNum)
{
  sprintf (s, "%s%04i.%s",SAVENAME,saveNum,SAVEEXT);
}

static void deleteGame (TWIN *win)
{
  char s [80];

  if (win->contentCount)
  {
    if (WIN_value (win) != EMPTYSLOT)
    {
      if (confirm ("     Delete this game ?   ") == YES)
      {
        getSaveFileName (s, WIN_value (win));
        unlink (s);
        WIN_deleteItem (win, win->contentCur);
        WIN_printContent (win, 0);
        saveCat (win);
      }
    }
  }
}

static int loadGame (void)
{
  int value;
  int exitCode = NONE;
  int com;
  char s [80];

  WIN_deleteContent (WinPickLoadFile);
  loadCat (WinPickLoadFile);
  WIN_open (WinLoad);

  do
  {
    com = WIN_insert (WinLoad);
    if (com == WIN_COM_DEL)
    {
      deleteGame (WinPickLoadFile);
    }
    else
    {
      if (com == WIN_COM_ESC)
      {
        exitCode = CANCEL;
      }
      else
      {
        if (WIN_subWin (WinLoad) == WinPickLoadFile)
        {
          value = LOAD;
        }
        else
        {
          value = WIN_value (WIN_subWin (WinLoad));
        }
        switch (value)
        {
          case LOAD:
          {
            if (WinPickLoadFile->contentCount)
            {
              getSaveFileName (s, WIN_value (WinPickLoadFile));
              if (!F_exist (s))
              {
                message ("     Error loading game");
              }
              else
              {
                exitCode = LOAD;//+WIN_value (WinPickLoadFile);
              }
              break;
            }
          }
          case DELETE:
          {
            deleteGame (WinPickLoadFile);
            break;
          }
          case CANCEL:
          {
            exitCode = CANCEL;
            break;
          }
        }
      }
    }
  }
  while (exitCode == NONE);
  WIN_close (WinLoad);
  return exitCode;
}

static int saveGame (void)
{
  char s [80];
  int value;
  int saveNum;
  int exitCode = NONE;
  int com;
  int i;

  WIN_deleteContent (WinPickSaveFile);
  WIN_appendList (WinPickSaveFile, "","[EMPTY SLOT]\n",EMPTYSLOT, NULL, -1);
  loadCat (WinPickSaveFile);
  WIN_open (WinSave);

  do
  {
    com = WIN_insert (WinSave);
    switch (com)
    {
      case WIN_COM_ESC:
      {
        exitCode = CANCEL;
        value = CANCEL;
        break;
      }
      case WIN_COM_DEL:
      {
        deleteGame (WinPickSaveFile);
        break;
      }
      default:
      {
        if ((WIN_subWin (WinSave) == WinSaveDesc) || (WIN_subWin (WinSave)
            == WinPickSaveFile))
        {
          value = SAVE;
        }
        else
          value = WIN_value (WIN_subWin (WinSave));
        break;
      }
    }

    switch (value)
    {
      case SAVE:
      {
        if (strlen (WinSaveDesc->content [0].item))
        {
          value = WIN_value (WinPickSaveFile);
          saveNum = value;
          if (value == EMPTYSLOT)
          {
            do
            {
              saveNum++;
              for (i = 1; i < WinPickSaveFile->contentCount; i++)
              {
                if (WinPickSaveFile->content [i].value == saveNum)
                  break;
              }
            }
            while (i < WinPickSaveFile->contentCount);

            WinPickSaveFile->content [EMPTYSLOT].value = saveNum;

          }
          strcpy (WinPickSaveFile->content [WinPickSaveFile->contentCur].item,
                  WinSaveDesc->content [0].item);
          if (strchr (WinPickSaveFile->content [WinPickSaveFile->contentCur].item,'\n')
                     == NULL)
          {
            strcat (WinPickSaveFile->content [WinPickSaveFile->contentCur].item,"\n");
          }
          saveCat (WinPickSaveFile);
          getSaveFileName (s, saveNum);
          if (F_write (s, NULL, 0))
          {
            message ("    Error saving game");
          }
          else
          {
            exitCode = SAVE;//+saveNum;
          }

        }
        break;
      }
      case DELETE:
      {
        deleteGame (WinPickSaveFile);
        break;
      }
      case CANCEL:
      {
        exitCode = CANCEL;
        break;
      }
    }
  }
  while (exitCode == NONE);
  WIN_close (WinSave);
  return exitCode;
}

static void makePickKey (void)
{
  WIN_deleteContent (WinPickKey);
  WIN_appendMenu (WinPickKey, " Move left    ", KEYB_desc (options.k_def.left), options.k_def.left, NULL, -1);
  WIN_appendMenu (WinPickKey, " Move right   ", KEYB_desc (options.k_def.right), options.k_def.right, NULL, -1);
  WIN_appendMenu (WinPickKey, " Move up      ", KEYB_desc (options.k_def.up), options.k_def.up, NULL, -1);
  WIN_appendMenu (WinPickKey, " Move down    ", KEYB_desc (options.k_def.down), options.k_def.down, NULL, -1);
  WIN_appendMenu (WinPickKey, " Fire         ", KEYB_desc (options.k_def.fire), options.k_def.fire, NULL, -1);
  WIN_appendMenu (WinPickKey, " Use/select   ", KEYB_desc (options.k_def.use), options.k_def.use, NULL, -1);
  WIN_appendMenu (WinPickKey, " Inventory    ", KEYB_desc (options.k_def.inv), options.k_def.inv, NULL, -1);
  WIN_appendMenu (WinPickKey, " Strafe on    ", KEYB_desc (options.k_def.strafe), options.k_def.strafe, NULL, -1);
  WIN_appendMenu (WinPickKey, " Strafe left  ", KEYB_desc (options.k_def.s_left), options.k_def.s_left, NULL, -1);
  WIN_appendMenu (WinPickKey, " Strafe right ", KEYB_desc (options.k_def.s_right), options.k_def.s_right, NULL, -1);
  WIN_appendMenu (WinPickKey, " Next player  ", KEYB_desc (options.k_def.next_p), options.k_def.next_p, NULL, -1);
  WIN_appendMenu (WinPickKey, " Next weapon  ", KEYB_desc (options.k_def.next_w), options.k_def.next_w, NULL, -1);
  WIN_appendMenu (WinPickKey, " Map          ", KEYB_desc (options.k_def.map), options.k_def.map, NULL, -1);
  WIN_appendMenu (WinPickKey, " Night vision ", KEYB_desc (options.k_def.n_vision), options.k_def.n_vision, NULL, -1);
  WIN_appendMenu (WinPickKey, " Weapon 1     ", KEYB_desc (options.k_def.weapon_1), options.k_def.weapon_1, NULL, -1);
  WIN_appendMenu (WinPickKey, " Weapon 2     ", KEYB_desc (options.k_def.weapon_2), options.k_def.weapon_2, NULL, -1);
  WIN_appendMenu (WinPickKey, " Weapon 3     ", KEYB_desc (options.k_def.weapon_3), options.k_def.weapon_3, NULL, -1);
  WIN_appendMenu (WinPickKey, " Weapon 4     ", KEYB_desc (options.k_def.weapon_4), options.k_def.weapon_4, NULL, -1);
}

static int setupKeys (void)
{
  int value;
  int exitCode = NONE;
  int com;
  char s [80];
  char c;
  Tk_def oldDef;

  makePickKey ();
  WIN_open (WinSetupKeys);

  oldDef = options.k_def;

  do
  {
    com = WIN_insert (WinSetupKeys);
    if (com == WIN_COM_DEL)
    {
      strcpy (WIN_itemStr (WinPickKey), KEYB_desc (0));
      WinPickKey->content [WinPickKey->contentCur].value = 0;
      WIN_printContent (WinPickKey, 0);
    }
    else
    {
      if (com == WIN_COM_ESC)
      {
        exitCode = CANCEL;
      }
      else
      {
        if (WIN_subWin (WinSetupKeys) == WinPickKey)
        {
          value = CHANGE;
        }
        else
        {
          value = WIN_value (WIN_subWin (WinSetupKeys));
        }
        switch (value)
        {
          case OK:
          {
            options.k_def.left = WIN_getValue (WinPickKey, 0);
            options.k_def.right = WIN_getValue (WinPickKey, 1);
            options.k_def.up = WIN_getValue (WinPickKey, 2);
            options.k_def.down = WIN_getValue (WinPickKey, 3);
            options.k_def.fire = WIN_getValue (WinPickKey, 4);
            options.k_def.use = WIN_getValue (WinPickKey, 5);
            options.k_def.inv = WIN_getValue (WinPickKey, 6);
            options.k_def.strafe = WIN_getValue (WinPickKey, 7);
            options.k_def.s_left = WIN_getValue (WinPickKey, 8);
            options.k_def.s_right = WIN_getValue (WinPickKey, 9);
            options.k_def.next_p = WIN_getValue (WinPickKey, 10);
            options.k_def.next_w = WIN_getValue (WinPickKey, 11);
            options.k_def.map = WIN_getValue (WinPickKey, 12);
            options.k_def.n_vision = WIN_getValue (WinPickKey, 13);
            options.k_def.weapon_1 = WIN_getValue (WinPickKey, 14);
            options.k_def.weapon_2 = WIN_getValue (WinPickKey, 15);
            options.k_def.weapon_3 = WIN_getValue (WinPickKey, 16);
            options.k_def.weapon_4 = WIN_getValue (WinPickKey, 17);
            exitCode = OK;
            break;
          }
          case CHANGE:
          {
            c = WIN_waitKey (WinPressKey);
            if ((c) && (c != KEY_ESC))
            {
              strcpy (WIN_itemStr (WinPickKey), KEYB_desc (c));
              WinPickKey->content [WinPickKey->contentCur].value = c;
              WIN_printContent (WinPickKey, 0);
            }
            break;
          }
          case CANCEL:
          {
            options.k_def = oldDef;
            exitCode = CANCEL;
            break;
          }
          case DEFAULTS:
          {
            defaultKeys ();
            makePickKey ();
            WIN_printContent (WinPickKey, 0);
            break;
          }
        }
      }
    }
  }
  while (exitCode == NONE);
  WIN_close (WinSetupKeys);

  return exitCode;
}


static int controls (void)
{
  int exitCode = NONE;
  int com;

  do
  {
    com = WIN_exec (WinControls);
    if (com == WIN_COM_ESC)
      exitCode = CANCEL;
    else
    {
      switch (WIN_value (WinControls))
      {
        case KEYBOARD:
        {
          setupKeys ();
          break;
        }
        case JOYSTICK:
        {
          calibrateJoy ();
          break;
        }
        case CANCEL:
        {
          exitCode = CANCEL;
        }
      }
    }
  }
  while (exitCode == NONE);

  return exitCode;
}


static int Options (void)
{
  int exitCode = NONE;
  int com;

  do
  {
    com = WIN_exec (WinOptions);
    if (com == WIN_COM_ESC)
      exitCode = CANCEL;
    else
    {
      switch (WIN_value (WinOptions))
      {
        case CONTROLS:
        {
          controls ();
          break;
        }
        case DEFAULTS:
        {
          break;
        }
        case CANCEL:
        {
          exitCode = CANCEL;
        }
      }
    }
  }
  while (exitCode == NONE);

  return exitCode;
}


static int multiplayer (void)
{
  int exitCode = NONE;
  int com;

  do
  {
    com = WIN_exec (WinMultiplayer);
    if (com == WIN_COM_ESC)
      exitCode = CANCEL;
    else
    {
      switch (WIN_value (WinMultiplayer))
      {
        case NETWORKGAME:
        {
          break;
        }
        case SERIALGAME:
        {
          break;
        }
        case CANCEL:
        {
          exitCode = CANCEL;
        }
      }
    }
  }
  while (exitCode == NONE);

  return exitCode;
}

static int mainmenu (void)
{
  int exitCode = NONE;
  int com;

  WIN_open (WinMain);
  do
  {
    com = WIN_insert (WinMain);

    if (com == WIN_COM_ESC)
    {
      exitCode = EXITGAME;
    }
    else
    {
      switch (WIN_value (WinMain))
      {
        case NEWGAME:
        {
          saveGame ();
///////   exitCode = NEWGAME;
          break;
        }

        case LOADGAME:
        {
          exitCode = loadGame ();
          break;
        }

        case MULTIPLAYER:
        {
          WIN_close (WinMain);
          multiplayer ();
          WIN_open (WinMain);
          break;
        }

        case OPTIONS:
        {
          WIN_close (WinMain);
          Options ();
          WIN_open (WinMain);
          break;
        }

        case INTRODUCTION:
        {
          exitCode = INTRODUCTION;
          break;
        }
        case EXITGAME:
        {
          if (confirm ("   Really exit the game ?    ") == YES)
          {
            exitCode = EXITGAME;
          }
          break;
        }
      }
    }
  }
  while (exitCode <= 0);

  WIN_close (WinMain);

  return exitCode;
}

static TWIN *WinButton (TWIN *win, char *str, int value, int x, int y)
{
  TWIN *button;

  button = WIN_newWinButton (str, value);
  if (button == NULL)
  {
    CGDK_exit ("Not enough memory for button.\n", 0);
  }

  WIN_setSpr (button, tile [TILE_BUTTON]);
  WIN_setColors (button, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  button->x = x;
  button->y = y;
  WIN_insertSubWin (win, button);
  return button;
}

static void initDialogLoad (void)
{
  WinLoad = WIN_new (20, WIN_FRAME);
  if (WinLoad == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinLoad);
  WIN_setBounds (WinLoad,  W_CENTER, W_CENTER, 38, 23);
  WIN_setColors (WinLoad, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WIN_setSpr (WinLoad,tile [TILE_LOAD]);

  WIN_appendComment (WinLoad, NULL);
  WIN_appendComment (WinLoad,"  Saved games descriptions");

  WinPickLoadFile = WIN_new (50, WIN_FRAME);
  WinPickLoadFile->commsAvail.del = 1;
  WIN_scrollBarEnable (WinPickLoadFile);
  WIN_setActiveFrame (WinPickLoadFile);
  WinPickLoadFile->shadow = 0;
  WIN_setBounds (WinPickLoadFile,  2, 3, 34, 16);
  WIN_setSpr (WinPickLoadFile, tile [TILE_LOADPICK]);
  WIN_setColors (WinPickLoadFile, C_CONTENT, C_SELECT, -1, -1, -1, -1, -1);
  WIN_insertSubWin (WinLoad, WinPickLoadFile);


  WinButton (WinLoad, "  Load  ", LOAD, 3, 20);
  WinButton (WinLoad, " Cancel ", CANCEL, 13, 20);
  WinButton (WinLoad, " Delete ", DELETE, 23, 20);
}

static void initDialogConfirm (void)
{
  WinConfirm = WIN_new (10, WIN_FRAME);
  if (WinConfirm == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }
  WIN_setActiveFrame (WinConfirm);
  WIN_setBounds (WinConfirm, W_CENTER, W_CENTER, 30, 8);
  WIN_setSpr (WinConfirm, tile [TILE_CONFIRM]);
  WIN_setColors (WinConfirm, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WIN_appendComment (WinConfirm, NULL);
  WIN_appendComment (WinConfirm, NULL);
  WinButton (WinConfirm, "  Yes  ",YES,5,5);
  WinButton (WinConfirm, "  No   ",NO,18,5);
}

static void initDialogMessage (void)
{
  WinMessage = WIN_new (10, WIN_FRAME);
  if (WinMessage == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinMessage);
  WIN_setBounds (WinMessage, W_CENTER, W_CENTER, 30, 8);
  WIN_setSpr (WinMessage, tile [TILE_MESSAGE]);
  WIN_setColors (WinMessage, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WIN_appendComment (WinMessage, NULL);
  WIN_appendComment (WinMessage, NULL);
  WinButton (WinMessage, "  OK  ",YES,12,5);
}


static void initDialogSave (void)
{
  WinSave = WIN_new (20, WIN_FRAME);
  if (WinSave == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinSave);
  WIN_setBounds (WinSave,  W_CENTER, W_CENTER, 38, 23);
  WIN_setSpr (WinSave, tile [TILE_SAVE]);
  WIN_setColors (WinSave, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);

  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave,"  Saved games descriptions");
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave, NULL);
  WIN_appendComment (WinSave,"  Description");

  WinPickSaveFile = WIN_new (50, WIN_FRAME);
  if (WinPickSaveFile == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WinPickSaveFile->commsAvail.del = 1;
  WIN_scrollBarEnable (WinPickSaveFile);
  WIN_setActiveFrame (WinPickSaveFile);
  WinPickSaveFile->shadow = 0;
  WIN_setBounds (WinPickSaveFile,  2, 3, 34, 11);
  WIN_setSpr (WinPickSaveFile, tile [TILE_SAVEPICK]);
  WIN_setColors (WinPickSaveFile, C_CONTENT, C_SELECT, -1, -1, -1, -1, -1);
  WIN_insertSubWin (WinSave, WinPickSaveFile);

  WinSaveDesc = WIN_new (1, WIN_FRAME);
  if (WinSaveDesc == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinSaveDesc);
  WinSaveDesc->shadow = 0;
  WIN_setBounds (WinSaveDesc, 2, 16, 34, 3);
  WIN_setColors (WinSaveDesc, C_CONTENT, -1, -1, -1, -1, -1, -1);
  WIN_appendItem (WinSaveDesc, WIN_ITEMT_INPUT2, "","",EMPTYSLOT, NULL, -1);
  WIN_setHumble (WinPickSaveFile, WinSaveDesc, 0);
  WIN_insertSubWin (WinSave, WinSaveDesc);

  WinButton (WinSave, "  Save  ", SAVE, 3, 20);
  WinButton (WinSave, " Cancel ", CANCEL, 13, 20);
  WinButton (WinSave, " Delete ", DELETE, 23, 20);
}

static void initDialogMain (void)
{
  WinMain = WIN_new (20, WIN_FRAME);
  if (WinMain == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinMain);
  WIN_setBounds (WinMain,  W_CENTER, W_CENTER, 18, 15);
  WIN_setSpr (WinMain, tile [TILE_MAIN]);
  WIN_setColors (WinMain, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);

  WIN_appendComment (WinMain, NULL);
  WIN_appendButton (WinMain, " ", "   New game   ", NEWGAME, NULL, -1);
  WIN_appendComment (WinMain, NULL);
  WIN_appendButton (WinMain, " ", "  Load game   ", LOADGAME, NULL, -1);
  WIN_appendComment (WinMain, NULL);
  WIN_appendButton (WinMain, " ", " Multiplayer  ", MULTIPLAYER, NULL, -1);
  WIN_appendComment (WinMain, NULL);
  WIN_appendButton (WinMain, " ", "   Options    ", OPTIONS, NULL, -1);
  WIN_appendComment (WinMain, NULL);
  WIN_appendButton (WinMain, " ", " Introduction ", INTRODUCTION, NULL, -1);
  WIN_appendComment (WinMain, NULL);
  WIN_appendButton (WinMain, "     ", " Exit ", EXITGAME, NULL, -1);
  WIN_scrollHome (WinMain);
}

static void initDialogOptions (void)
{
  TWINItem *item;

  WinOptions = WIN_new (20, WIN_FRAME);
  if (WinOptions == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinOptions);
  WIN_setBounds (WinOptions,  W_CENTER, W_CENTER, 28, 16);
  WIN_setSpr (WinOptions, tile [TILE_OPTIONS]);
  WIN_setColors (WinOptions, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WinOptions->color.h_barSelect = C_BPUSH;
  WIN_appendComment (WinOptions, NULL);
  item = WIN_item (WinOptions,
                   WIN_appendItem (WinOptions, WIN_ITEMT_SCROLLBAR,
                   " Sound volume  ", "<========>", -1, NULL, -1));
  item->maxLen = 64;
  item->step = 8;
  item = WIN_item (WinOptions,
                   WIN_appendItem (WinOptions, WIN_ITEMT_SCROLLBAR,
                   " Music volume  ", "<========>", -1, NULL, -1));
  item->maxLen = 60;
  item->step = 10;

  item = WIN_item (WinOptions,
                   WIN_appendItem (WinOptions, WIN_ITEMT_SCROLLBAR,
                   " Brightness    ", "<========>", -1, NULL, -1));
  item->maxLen = 80;
  item->step = 10;

  WIN_appendComment (WinOptions, NULL);
  WIN_appendCheckBox (WinOptions,
                   " Reverse stereo         ", NULL, -1, NULL, -1);
  WIN_appendCheckBox (WinOptions,
                   " Double buffered screen ", NULL, -1, NULL, -1);

  WIN_appendComment (WinOptions, NULL);
  WIN_appendButton (WinOptions, "       ", "  Controls  ", CONTROLS, NULL, -1);
  WIN_appendComment (WinOptions, NULL);
  WIN_appendButton (WinOptions, "       ", "  Defaults  ", DEFAULTS, NULL, -1);
  WIN_appendComment (WinOptions, NULL);
  WIN_appendButton (WinOptions, "         ", " Cancel ", CANCEL, NULL, -1);
  WIN_scrollHome (WinOptions);
}

static void initDialogMultiplayer (void)
{
  WinMultiplayer = WIN_new (10, WIN_FRAME);
  if (WinMultiplayer == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinMultiplayer);
  WIN_setBounds (WinMultiplayer,  W_CENTER, W_CENTER, 18, 9);
  WIN_setSpr (WinMultiplayer, tile [TILE_MULTIPLAYER]);
  WIN_setColors (WinMultiplayer, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, -1, -1, -1);

  WIN_appendComment (WinMultiplayer, NULL);
  WIN_appendButton (WinMultiplayer, " ", " Network game ", NETWORKGAME, NULL, -1);
  WIN_appendComment (WinMultiplayer, NULL);
  WIN_appendButton (WinMultiplayer, " ", " Serial game  ", SERIALGAME, NULL, -1);
  WIN_appendComment (WinMultiplayer, NULL);
  WIN_appendButton (WinMultiplayer, "    ", " Cancel ", CANCEL, NULL, -1);
  WIN_scrollHome (WinMultiplayer);
}


static void initDialogControls (void)
{
  WinControls = WIN_new (10, WIN_FRAME);
  if (WinControls == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinControls);
  WIN_setBounds (WinControls,  W_CENTER, W_CENTER, 24, 9);
  WIN_setSpr (WinControls, tile [TILE_CONTROLS]);
  WIN_setColors (WinControls, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);

  WIN_appendComment (WinControls, NULL);
  WIN_appendButton (WinControls, " ", " Customize keyboard ", KEYBOARD, NULL, -1);
  WIN_appendComment (WinControls, NULL);
  WIN_appendButton (WinControls, " ", " Calibrate joystick ", JOYSTICK, NULL, -1);
  WIN_appendComment (WinControls, NULL);
  WIN_appendButton (WinControls, "       ", " Cancel ", CANCEL, NULL, -1);
  WIN_scrollHome (WinControls);
}

static void initDialogSetupKeys (void)
{
  WinSetupKeys = WIN_new (20, WIN_FRAME);
  if (WinSetupKeys == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }


  defaultKeys ();

  WIN_setActiveFrame (WinSetupKeys);
  WIN_setBounds (WinSetupKeys,  W_CENTER, W_CENTER, 38, 23);
  WIN_setSpr (WinSetupKeys, tile [TILE_SETUPKEYS]);
  WIN_setColors (WinSetupKeys, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WIN_appendComment (WinSetupKeys, NULL);
  WIN_appendComment (WinSetupKeys,"  Defined keys");

  WinPickKey = WIN_new (50, WIN_FRAME);
  if (WinPickKey == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WinPickKey->commsAvail.del = 1;
  WIN_scrollBarEnable (WinPickKey);
  WIN_setActiveFrame (WinPickKey);
  WinPickKey->shadow = 0;
  WIN_setBounds (WinPickKey,  2, 3, 34, 16);
  WIN_setSpr (WinPickKey, tile [TILE_PICKKEY]);
  WIN_setColors (WinPickKey, C_CONTENT, C_SELECT, -1, -1, -1, -1, -1);
  WIN_insertSubWin (WinSetupKeys, WinPickKey);

  WinButton (WinSetupKeys, " OK ", OK, 3, 20);
  WinButton (WinSetupKeys, " Change ", CHANGE, 8, 20);
  WinButton (WinSetupKeys, " Default ", DEFAULTS, 17, 20);
  WinButton (WinSetupKeys, " Cancel ", CANCEL, 27, 20);
}

static void initDialogPressKey (void)
{
  WinPressKey = WIN_new (3, WIN_FRAME);
  if (WinPressKey == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinPressKey);
  WIN_setBounds (WinPressKey,  W_CENTER, W_CENTER, 17, 5);
  WIN_setSpr (WinPressKey, tile [TILE_PRESSKEY]);
  WIN_setColors (WinPressKey, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WIN_appendComment (WinPressKey, NULL);
  WIN_appendComment (WinPressKey, "  Press a key");
}

static void initDialogCalibrateJoy (void)
{
  WinCalibrateJoy = WIN_new (10, WIN_FRAME);
  if (WinCalibrateJoy == NULL)
  {
    CGDK_exit ("Not enough memory for window.\n", 0);
  }

  WIN_setActiveFrame (WinCalibrateJoy);
  WIN_setBounds (WinCalibrateJoy,  W_CENTER, W_CENTER, 35, 7);
  WIN_setSpr (WinCalibrateJoy, tile [TILE_CALIBRATEJOY]);
  WIN_setColors (WinCalibrateJoy, C_CONTENT, C_BSELECT, C_BPUSH, C_BUTTON, C_BUTTON, -1, -1);
  WIN_appendComment (WinCalibrateJoy, NULL);
  WIN_appendComment (WinCalibrateJoy, NULL);
  WIN_appendComment (WinCalibrateJoy, NULL);
  WIN_appendComment (WinCalibrateJoy, NULL);
  WIN_appendComment (WinCalibrateJoy, "       Press Escape to abort");
}

int main (void)
{
  int com;
  int exitCode;
  TCAR *carHandle;
  TRGBColor pal [256] = {0};
  TCSF *mouseCSF, *cursorCSF;
  char fileName [80];
  int i;
  int videoMode;

  printf ("\n"
          "MAIN - example of the CGDK window menu system\n"
          "\n%s\n",CGDK_copyright);

  CGDK_init ();
  TIMER_init (TIMER_OLDFREQ_DEF);

  switch (_argc)
  {
    case 1:
    {
      videoMode = 0;
      break;
    }
    case 2:
    {
      sscanf (_argv [1], "%i", &videoMode);
      break;
    }
    default:
    {
      CGDK_exit ("Syntax is: MAIN <video_mode>\n", 0);
    }
  }

  carHandle = CAR_open (CAR_EMULATION);

  if ((unsigned)videoMode >= 0x13)
  {
    if (SVGA_compatible & VESA_COMPATIBLE)
    {
      SVGA_setVideoMode (videoMode);
      PAL_clear (0, 256);
      SVGA_clear (1);
      TM_font [0] = CSF_new (carHandle, CSF_FONT0);
      if (TM_font [0] == NULL)
      {
        CGDK_exit ("Error loading "CSF_FONT0"\n", 0);
      }

      TM_font [C_CONTENT] = CSF_dup (TM_font [0]);
      PAL_rotateRed (TM_font [C_CONTENT]->colors, TM_font [0]->maxColor);
      CSF_updateColors (TM_font [C_CONTENT], pal, 1, 255);

      TM_font [C_SELECT] = CSF_dup (TM_font [0]);
      PAL_rotateBlue (TM_font [C_SELECT]->colors, TM_font [0]->maxColor);
      CSF_updateColors (TM_font [C_SELECT], pal, 1, 255);

      TM_font [C_BUTTON] = CSF_dup (TM_font [0]);
      PAL_mirrorRed (TM_font [C_BUTTON]->colors, TM_font [0]->maxColor);
      CSF_updateColors (TM_font [C_BUTTON], pal, 1, 255);

      TM_font [C_BSELECT] = CSF_dup (TM_font [0]);
      PAL_mirrorGreen (TM_font [C_BSELECT]->colors, TM_font [0]->maxColor);
      CSF_updateColors (TM_font [C_BSELECT], pal, 1, 255);

      TM_font [C_BPUSH] = CSF_dup (TM_font [0]);
      PAL_mirrorBlue (TM_font [C_BPUSH]->colors, TM_font [0]->maxColor);
      CSF_updateColors (TM_font [C_BPUSH], pal, 1, 255);

      CSF_updateColors (TM_font [0], pal, 1, 255);

      mouseCSF = CSF_new (carHandle, CSF_MOUSECURSOR);
      if (mouseCSF == NULL)
      {
        CGDK_exit ("Error loading "CSF_MOUSECURSOR"\n", 0);
      }

      CSF_updateColors (mouseCSF, pal, 1, 255);
      MOUSE_setCursor (mouseCSF, 0);
//      MOUSE_setSensitivity (2,2);

      cursorCSF = CSF_new (carHandle, CSF_CURSOR);
      if (cursorCSF == NULL)
      {
        CGDK_exit ("Error loading "CSF_CURSOR"\n", 0);
      }

      CSF_updateColors (cursorCSF, pal, 1, 255);

      TM_setCursor (cursorCSF, 0, TM_CURSORFREQ_DEF);

      #ifndef __TURBOC__
        i = -1;
        do
        {
          i++;
          sprintf (fileName, CSF_TILENAME"%i.csf", i);
          tile [i] = CSF_new (carHandle, fileName);
          CSF_updateColors (tile [i], pal, 1, 255);
        }
        while (tile [i] != NULL);

      #endif
    }
    else
    {
      CGDK_exit ("VESA compatible videocard required.\n", 1);
    }
  }
  else
  {
    SVGA_setVideoMode (videoMode);
  }

  if (WIN_init () == 0)
  {
    MOUSE_showCursor ();
    WIN_setDesktop (' ', 0, tile [TILE_DESKTOP]);
    WIN_redrawScreen ();
    if (SVGA_graph)
      PAL_set (pal, 0, 256);

    initDialogMain ();
    initDialogConfirm ();
    initDialogMessage ();
    initDialogSave ();
    initDialogLoad ();
    initDialogOptions ();
    initDialogMultiplayer ();
    initDialogControls ();
    initDialogSetupKeys ();
    initDialogPressKey ();
    initDialogCalibrateJoy ();

    if (F_read (CONFIG_FILENAME, (void *) &options, sizeof options, 0) != 0)
    {
      defaultKeys ();
    }

    if (!JOY_state.a.installed)
    {
      calibrateJoy ();
    }

    exitCode = mainmenu ();

    F_write (CONFIG_FILENAME, (void *) &options, sizeof options);

    WIN_done ();
  }
  else
  {
    CGDK_exit ("Not enough memory.\n", 0);
  }

  SVGA_done ();

  return exitCode;
}
