
#ifndef _MIR_H
  #define _MIR_H

  #ifdef __cplusplus
  extern "C" {
  #endif


  #include <stdlib.h>

  #define MIR_TYPE_SHADENONE 0
  #define MIR_TYPE_SHADEMAP 1
  #define MIR_TYPE_SHADEOWN 2
  #define MIR_TYPE_SHADEBOTH 3

  #define MIR_TYPE_STATIC 4

//  #define MIR_STATUS_UPDATE 0
  #define MIR_STATUS_REDRAW 1
  #define MIR_STATUS_RESTORE 2
  #define MIR_STATUS_UPDATE 4
  #define MIR_STATUS_DELETE 8
  #define MIR_STATUS_CACHE 16

  #ifndef __TURBOC__
    #define MIR_MAXDEF_SIZE (128*128)
  #else
    #define MIR_MAXDEF_SIZE (32*32)
  #endif

  typedef struct {
    int  type;
    int  layer;
    int  x;
    int  y;
    int  curX;
    int  curY;
    int  sizeX;
    int  sizeY;
    int  size;
    int  status;

    char *spr;
    char *raw;
    char *shade;
    char *pool;
  } TMIR;

  #include "mirc_.h"
  #include "mirl_.h"

  extern void MIR_init (int maxLayer, int maxSize); // =MIRL_MAXDEF, =MIR_DEFSIZEX, =MIR_DEFSIZEY
  extern void MIR_done (void);
  extern TMIR *MIR_new (void *raw, int sizeX, int sizeY, int layer, int type, char *shade); // =MIRL_NONE, =MIR_TYPE_SHADENONE, =NULL
  extern void MIR_changeSpr (TMIR *mir, void *newSpr); // int sizeX, int sizeY);
//  extern void MIR_changeMode (TMIR *mir, int type=MIR_TYPE_SHADENONE, char *shade=NULL);
  extern void MIRC_update (TMIR *MIR, int x, int y);
  #define MIR_updateDelta(MIR,dx,dy) MIR_update (MIR,MIR->x+dx-SVGA_dx,MIR->y+dy-SVGA_dy)
  extern void MIR_restore (TMIR *MIR);
  extern void MIR_delete (TMIR *MIR);
  extern void MIR_free (TMIR *MIR);
  extern void MIR_updateCurPos (TMIR *mir);
  extern void MIR_shade (TMIR *mir);

  #ifdef __cplusplus
  }
  #endif

#endif
