
#include <mem.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>

#include "dpmi.h"

#include "svga.h"
#include "pal.h"
#include "timer.h"
#include "keyb.h"
#include "scroll.h"
#include "cgdk.h"
#include "vsb.h"
#include "mouse.h"
#include "tm.h"
#include "cgdk.h"

extern "C" void SVGA_longNull (long)
{

}

extern "C" void SVGA_intNull (int)
{

}

extern "C" void SVGA_voidNull (void)
{

}

int SVGA_enableRetrace;


void (*SVGA_setPal) (TRGBColor *Pal, int StartColor, int NumColors);
void (*SVGA_getPal) (TRGBColor *Pal, int StartColor, int NumColors);
void (*SVGA_clearPal) (int StartColor, int NumColors);

extern "C" {
int SVGA_init (void);

void (*SVGA_scroll) (void)=SVGA_voidNull;
void (*SVGA_setBank) (int bank)=SVGA_intNull;
void (*SVGA_clear_) (long Color)=SVGA_longNull;

//void (*SVGA_cflush) (void)=SVGA_voidNull;
//void (*SVGA_cdone) (void)=SVGA_voidNull;

void (*SVGA_putSpr_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
void (*SVGA_putWin_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
//void (*SVGA_putBorder_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
//void (*SVGA_movSpr_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
//void (*SVGA_movWin_) (void *Win, int X, int Y, int Size_X, int Size_Y, int formatX);
void (*SVGA_getWin_) (void *Spr, int X, int Y, int Size_X, int Size_Y, int formatX);
void (*SVGA_putPixel_) (int X, int Y, long Pixel);
//void (*SVGA_movPixel_) (int X, int Y, long Pixel);
long (*SVGA_getPixel_) (int X, int Y);
}

//int SVGA_VESA12_mode;
int SVGA_virtualX,SVGA_virtualY;
int SVGA_virtualXD2, SVGA_virtualYD2;
long SVGA_virtual;
long SVGA_virtualPool;
long SVGA_virtual2;
long SVGA_virtualD4;
int SVGA_scanLines;
int SVGA_curX,SVGA_curY;
int SVGA_curXNext,SVGA_curYNext;
int SVGA_curXPrev,SVGA_curYPrev;
int SVGA_dx, SVGA_dy;
int SVGA_maxX,SVGA_maxY;
int SVGA_maxXPlus;
int SVGA_maxYPlus;
int SVGA_graph;
long SVGA_max;
int SVGA_enableVESA=1;

int SVGA_bytesPerPixel;
int SVGA_bitsPerPixel;
int SVGA_doubleBuffer;
int SVGA_palType;
static int SVGA_defaultMode = -1;
int SVGA_videoMode = -1;
int SVGA_compatible = NOT_COMPATIBLE;
void far *SVGA_linearBuf;
void *SVGA_linearOff;
void *SVGA_linearOff2;
int SVGA_linearSeg;
double SVGA_freq;

long SVGA_setBankCount;

void SVGA_putWin (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      VSB_putWin ((char *)win+startX+startY*formatX, x+startX, y+startY,
                 sizeX-startX, sizeY-startY, formatX);
      SVGA_putWin_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}

void SVGA_putSpr (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      VSB_putSpr ((char *)win+startX+startY*formatX, x+startX, y+startY,
                 sizeX-startX, sizeY-startY, formatX);
      SVGA_putSpr_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}

/*
void SVGA_movWin (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      VSB_putWin ((char *)win+startX+startY*formatX, x+startX, y+startY,
                 sizeX-startX, sizeY-startY, formatX);
      SVGA_movWin_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}

void SVGA_movSpr (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      VSB_putSpr ((char *)win+startX+startY*formatX, x+startX, y+startY,
                 sizeX-startX, sizeY-startY, formatX);
      SVGA_movSpr_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}
*/

void SVGA_getWin (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      VSB_getWin ((char *)win+startX+startY*formatX, x+startX, y+startY,
               sizeX-startX, sizeY-startY, formatX);
    }
  }
}

void SVGA_putWinNoVSB (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      SVGA_putWin_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}

void SVGA_putSprNoVSB (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      SVGA_putSpr_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}

/*
void SVGA_movWinNoVSB (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      SVGA_movWin_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}

void SVGA_movSprNoVSB (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      SVGA_movSpr_((char *)win+startX+startY*formatX, x+startX, y+startY,
                sizeX-startX, sizeY-startY, formatX);
    }
  }
}
*/

void SVGA_getWinNoVSB (void *win, int x, int y, int SIZE_X, int SIZE_Y, int formatX)
{
  int sizeX;
  int sizeY;
  int startX;
  int startY;

  startX = (x > 0) ? 0 : -x;
  startY = (y > 0) ? 0 : -y;

  if ((startX < SIZE_X) && (startY < SIZE_Y))
  {
    sizeX = ((x + SIZE_X) <= SVGA_maxX) ? SIZE_X : SVGA_maxX - x;
    sizeY = ((y + SIZE_Y) <= SVGA_maxY) ? SIZE_Y : SVGA_maxY - y;

    if ((sizeX > 0) && (sizeY > 0))
    {
      SVGA_getWin_ ((char *)win+startX+startY*formatX, x+startX, y+startY,
                  sizeX-startX, sizeY-startY, formatX);
    }
  }
}

/*
void SVGA_movPixel (int x, int y, long color)
{
  long offset;

  if (color)
  {
    SVGA_movPixel_ (x, y, color);
    VSB_putPixel (x, y, color);
  }
}
*/

void SVGA_putPixel (int x, int y, long color)
{
  long offset;

  if (color)
  {
    SVGA_putPixel_ (x, y, color);
    VSB_putPixel (x, y, color);
  }
}

long SVGA_getPixel (int x, int y)
{
  return VSB_getPixel (x, y);
}

void SVGA_clear (long color)
{
  if (VSB_buf)
  {
    memset (VSB_buf, color, VSB_virtual);
  }

  SVGA_clear_ (color);
}

/*
void SVGA_movPixelNoVSB (int x, int y, long color)
{
  SVGA_movPixel_ (x, y, color);
}
*/

void SVGA_putPixelNoVSB (int x, int y, long color)
{
  SVGA_putPixel_ (x, y, color);
}

long SVGA_getPixelNoVSB (int x, int y)
{
  return SVGA_getPixel_ (x,y);
}

void SVGA_clearNoVSB (long color)
{
  SVGA_clear_ (color);
}


void SVGA_virtual2Real (int *_x, int *_y)
{
  int x = *_x;
  int y = *_y;

  if (x < 0)
  {
    x += SVGA_virtualX;
    y --;
  }
  if (y < 0)
  {
    y += SVGA_virtualY;
  }

  if (x >= SVGA_virtualX)
  {
    x -= SVGA_virtualX;
    y ++;
  }

  if (y >= SVGA_virtualY)
  {
    y -= SVGA_virtualY;
  }
  *_x = x;
  *_y = y;
}

void SVGA_updateCurPos (int x, int y)
{
  SVGA_curX += x;
  SVGA_curY += y;
  SVGA_virtual2Real (&SVGA_curX, &SVGA_curY);

  VSB_curX += x;
  VSB_curY += y;
  VSB_virtual2Real (&VSB_curX, &VSB_curY);
}


// check the equipment
int SVGA_init (void)
{
  REGS regs;

  if (SVGA_compatible == NOT_COMPATIBLE)
  {
    VGA_init ();
    if (VGA_installed)
    {
      SVGA_compatible = VGA_COMPATIBLE;
      SVGA_defaultMode = SVGA_returnVideoMode ();
      SVGA_videoBuf = SVGA_getVideoBuf (SVGA_defaultMode);

      if (VESA_init ())
      {
        SVGA_compatible |= VESA_COMPATIBLE;
      }

      SVGA_videoMode = VGA_80xXXx16TM;

//      TM_setup ();

      SVGA_palType = PAL_6BIT;

      SVGA_videoBuf = SVGA_getVideoBuf (SVGA_videoMode);

      SVGA_linearSeg = 0;
      #ifdef __TURBOC__
        SVGA_linearBuf = SVGA_videoBuf;
        SVGA_linearOff = SVGA_videoBuf;
      #else
        SVGA_linearBuf = MK_FP (DPMI_getDS (), VGA_SEG * 16);
        SVGA_linearOff = (void *) (VGA_SEG * 16);
      #endif
      SVGA_linearOff2 = SVGA_linearOff;

      VGA_getModeInfo (SVGA_videoMode, &SVGA_maxX, &SVGA_maxY, &SVGA_bytesPerPixel, &SVGA_bitsPerPixel);
      SVGA_max = (unsigned) SVGA_maxX*SVGA_maxY;
      SVGA_virtualX = SVGA_maxX;
      SVGA_virtualY = SVGA_maxY;
      SVGA_virtual = (long) SVGA_virtualX*SVGA_virtualY;
      SVGA_doubleBuffer = 0;
      SVGA_palType = PAL_6BIT;
      SVGA_scanLines = SVGA_virtualY;
      SVGA_curX = SVGA_curY = 0;
      SVGA_curXNext = SVGA_curYNext = 0;
      SVGA_maxXPlus = SVGA_maxYPlus = 0;
  //    SVGA_clear_ = SVGA_longNull;
  //    SVGA_scroll = SVGA_voidNull;
  //    SVGA_setBank = SVGA_intNull;
  //    SVGA_scroll = SVGA_voidNull;
      SVGA_virtualXD2 = SVGA_virtualX/2;
      SVGA_virtualYD2 = SVGA_virtualY/2;
      SVGA_virtualD4 = SVGA_virtual/4;
      SVGA_virtual2 = 2*SVGA_virtual;
      SVGA_virtualPool = SVGA_virtualX * SVGA_scanLines;
    }
  }
  return SVGA_compatible;
}

int SVGA_getModeInfo ( int Mode, int *XRes, int *YRes,
                      int *BytesPerLine,int *BitsPerPixel)
{
  int exitCode, xres, yres, bytes, bits;

  if ((unsigned)Mode < VESA_MODE)
  {
    exitCode = VGA_getModeInfo (Mode, &xres, &yres, &bytes, &bits);
  }
  else
  {
    if (Mode & XVGA)
    {
      exitCode = XVGA_getModeInfo (Mode, &xres, &yres, &bytes, &bits);
    }
    else
    {
      exitCode = VESA_getModeInfo (Mode, &xres, &yres, &bytes, &bits);
    }
  }
  if (XRes)
    *XRes = xres;
  if (YRes)
    *YRes = yres;
  if (BytesPerLine)
    *BytesPerLine = bytes;
  if (BitsPerPixel)
    *BitsPerPixel = bits;

  return exitCode;
}


void SVGA_clearScreen (void)
{
  if (SVGA_graph)
  {
    PAL_clear (0, 256);
    SVGA_waitRetrace (1);
    SVGA_clear (0);
    SVGA_scroll ();
    PAL_setDefault ();
  }
}

void SVGA_restoreVideoMode (void)
{
  KEYB_updateLock = 1;

  if (SVGA_graph)
  {
    SVGA_clearScreen ();
  }
  SVGA_maxX = SVGA_maxY = SVGA_max = 0;
  VSB_done ();
  TM_restore ();

  #ifndef CGDK_TRIAL
    if (SVGA_getWin_ == B256_getWin)
    {
      B256C_done ();
    }
  #endif

  SVGAC_done ();

  SVGA_videoMode = 0;
  KEYB_updateLock = 0;

//  SVGA_cdone = SVGA_voidNull;
  SVGA_clear_ = SVGA_longNull;
  SVGA_scroll = SVGA_voidNull;
  SVGA_setBank = SVGA_intNull;
//  SVGA_cflush = SVGA_voidNull;
}

void SVGA_done (void)
{
  SVGA_restoreVideoMode ();
  VESA_done ();
  SVGA_compatible = NOT_COMPATIBLE;
}

void SVGA_setDefaultMode (void)
{
  if (SVGA_defaultMode != -1)
  {
    VGA_setVideoMode (SVGA_defaultMode); // set
  }
}

int SVGA_switchDefaultMode (void)
{
  return VGA_setVideoMode (SVGA_defaultMode);
}

static int SVGA_setXMode (int mode)
{
  int result;

  result = XVGA_setVideoMode (mode);
  if (result == SVGA_SETMODE_OK)
  {
    SVGA_clear_         = X256_clear;
    SVGA_setBank = XVGA_setWritePlane;
    if (!SVGA_doubleBuffer)
    {
//      SVGA_movSpr_        = X256_movSpr;
//      SVGA_movWin_        = X256_movWin;
      SVGA_putSpr_ = X256_putSpr;
      SVGA_putWin_ = X256_putWin;
    }
    else
    {
//      SVGA_movSpr_        = X256_movSpr2;
//      SVGA_movWin_        = X256_movWin2;
      SVGA_putSpr_ = X256_putSpr2;
      SVGA_putWin_ = X256_putWin2;
    }
//    SVGA_putBorder_ = SVGA_movWin_;
    SVGA_getWin_           = X256_getWin;
//    SVGA_movPixel_      = X256_movPixel;
    SVGA_putPixel_      = X256_putPixel;
    SVGA_getPixel_      = X256_getPixel;
//    SVGA_cflush = X256C_flush;
//    X256C_init ();
//    SVGA_cdone = X256C_done;

    SVGA_scroll         = XVGA_scroll;

    if ( VSB_init () != 0 )
    {
      SVGA_graph = 0;
      result = SVGA_SETMODE_OUTOFMEMORY;
    }
    else
    {
      SVGA_clearScreen ();
    }
  }
  return result;
}


static int SVGA_setVGAMode (int mode)
{
  int result;

  result = VGA_setVideoMode (mode);

  if (result == 0)
  {
    SVGA_clear_    = L256_clear;
//    SVGA_movSpr_   = L256_movSpr;
//    SVGA_movWin_   = L256_movWin;
    SVGA_putSpr_   = L256_putSpr;
    SVGA_putWin_   = L256_putWin;
//    SVGA_putBorder_ = SVGA_movWin_;
    SVGA_getWin_      = L256_getWin;
//    SVGA_movPixel_ = L256_movPixel;
    SVGA_putPixel_ = L256_putPixel;
    SVGA_getPixel_ = L256_getPixel;
//    L256C_init ();
//    SVGA_cflush = L256C_flush;
//    SVGA_cdone = L256C_done;

    if ( VSB_init () != 0 )
    {
      SVGA_graph = 0;
      result = SVGA_SETMODE_OUTOFMEMORY;
    }
//    SVGA_clearScreen ();
  }
  return result;
}


static int SVGA_setVESAMode (int mode)
{
  int result;

  result = VESA_setVideoMode (mode);
  if (result == SVGA_SETMODE_OK)
  {
    SVGA_scroll      = VESA_scroll;
    SVGA_setBank = VESA_setBank;

    if (SVGA_linearSeg)
    {
      switch (SVGA_bytesPerPixel)
      {
        case 1:
        {
          SVGA_clear_    = L256_clear;
          if (!SVGA_doubleBuffer)
          {
//            SVGA_movSpr_     = L256_movSpr;
//            SVGA_movWin_     = L256_movWin;
            SVGA_putSpr_     = L256_putSpr;
            SVGA_putWin_     = L256_putWin;
          }
          else
          {
            #ifndef __TURBOC__
//            SVGA_movSpr_     = L256_movSpr2;
//            SVGA_movWin_     = L256_movWin2;
            SVGA_putSpr_     = L256_putSpr2;
            SVGA_putWin_     = L256_putWin2;
            #else
               CGDK_exit ("No support for double buffered SVGA modes in real mode.\n", EXIT_FAILURE);
            #endif
          }
//          SVGA_putBorder_ = SVGA_movWin_;
          SVGA_getWin_      = L256_getWin;
//          SVGA_movPixel_ = L256_movPixel;
          SVGA_putPixel_ = L256_putPixel;
          SVGA_getPixel_ = L256_getPixel;
//          SVGA_cflush = L256C_flush;
//          L256C_init ();
//          SVGA_cdone = L256C_done;
          break;
        }
        default:
          return SVGA_SETMODE_NOHICOLORSUPPORT;
      }
    }
    else
    {
      #ifndef CGDK_TRIAL

      switch (SVGA_bytesPerPixel)
      {
        case 1:
        {
          SVGA_clear_    = B256_clear;
          if (!SVGA_doubleBuffer)
          {
            SVGA_putSpr_     = B256_putSpr;
            SVGA_putWin_     = B256_putWin;
//            SVGA_movSpr_     = B256_movSpr;
//            SVGA_movWin_     = B256_movWin;
          }
          else
          {
            SVGA_putSpr_     = B256_putSpr2;
            SVGA_putWin_     = B256_putWin2;
//            SVGA_movSpr_     = B256_movSpr2;
//          SVGA_movWin_     = B256_movWin2;
          }
//          if (VESA_version <= VESA_12)
//          {
//          SVGA_putBorder_ = SVGA_putWin_;
//          }
//          else
//          {
//            SVGA_putBorder_ = SVGA_movWin_;
//          }
//          SVGA_cflush     = B256C_flush;
          SVGA_getWin_      = B256_getWin;
//          SVGA_movPixel_ = B256_movPixel;
          SVGA_putPixel_ = B256_putPixel;
          SVGA_getPixel_ = B256_getPixel;
          B256C_init ();
//          SVGA_cdone = B256C_done;
          break;
        }
        default:
        {
          return SVGA_SETMODE_NOHICOLORSUPPORT;
        }
      }

      #else

      SVGA_graph = 0;
      CGDK_exitTrial ();

      #endif
//      if (VESA_version == VESA_12)
//      {
//      SVGA_VESA12_mode = 1;

//      }
    }

    if ( VSB_init () != 0 )
    {
      SVGA_graph = 0;
      result = SVGA_SETMODE_OUTOFMEMORY;
    }
    else
    {
      SVGA_clearScreen ();
    }
  }
  return result;
}

int SVGA_setVideoMode ( int mode)
{
  int result;

  if (SVGA_compatible)
  {
    if (SVGA_videoModeSupported (mode)==0)
    {
      if (SVGA_videoMode != mode)
      {
        TM_setup ();
//        _atexit (SVGA_done);

//        SVGA_VESA12_mode = 0;
//        SVGA_cdone ();
//        SVGA_cdone = SVGA_voidNull;

        SVGA_clear_ = SVGA_longNull;
        SVGA_scroll = SVGA_voidNull;
        SVGA_setBank = SVGA_intNull;
//        SVGA_cflush = SVGA_voidNull;

        if ((mode & XVGA) == XVGA)
        {
          result = SVGA_setXMode (mode);
          if (result != SVGA_SETMODE_OK)
          {
            return result;
          }
        }
        else
        {
          if (mode <= VGA_MAXMODE)
          {
            if (SVGA_setVGAMode (mode) != SVGA_SETMODE_OK)
            {
              return SVGA_SETMODE_NOTCOMPATIBLE;
            }
          }
          else
          {
            if (mode >= VESA_MODE)
            {
              result = SVGA_setVESAMode (mode);
              if (result != SVGA_SETMODE_OK)
              {
                return result;
              }
            }
          }
        }
        SVGA_videoMode = mode;
        if ((SVGA_maxX == SVGA_virtualX) && (SVGA_maxY == SVGA_virtualY))
        {
          SVGA_scroll = SVGA_voidNull;
        }
        MOUSE_install ();
      }
      else
      {
        SVGA_clearScreen ();
      }

      SVGA_enableRetrace = 0;

      if (SVGA_graph)
      {
	if (SVGA_scroll != SVGA_voidNull)
	{
	  SVGA_enableRetrace = 1;
	  SVGA_retraceInit ();
	}
      }
      SVGA_virtualXD2 = SVGA_virtualX/2;
      SVGA_virtualYD2 = SVGA_virtualY/2;
      SVGA_virtualD4 = SVGA_virtual/4;
      SVGA_virtual2 = 2*SVGA_virtual;
      SVGA_virtualPool = SVGA_virtualX * SVGA_scanLines;

      return SVGA_SETMODE_OK;
    }
//    else
//    {
//      CGDK_abort ("You have attempted to set an incorrect video mode.\n"
//                  "The video mode is either unsupported on your machine\n"
//                  "or the requested video mode number is invalid.\n"
//                  "To avoid this message, call SVGA_videoModeSupported ()\n"
//                  "before SVGA_setVideoMode () to check if video mode supported\n"
//                  "by your own.\n"
//                  "\n");
//    }
    return SVGA_SETMODE_NOSUPPORT;
  }
  return SVGA_SETMODE_NOTCOMPATIBLE;
}

int SVGA_videoModeSupported ( int VideoMode)
{
  if ((unsigned)VideoMode <= VGA_MAXMODE)
    return ((SVGA_compatible & VGA_COMPATIBLE) == 0);
  if (VideoMode & XVGA)
  {
    return XVGA_videoModeSupported (VideoMode);
  }
  if (VideoMode >= VESA_MODE)
  {
    if (SVGA_compatible & VESA_COMPATIBLE)
      return VESA_videoModeSupported (VideoMode);
    return 2;
  }
  return 1;
}


static int SVGA_recommendLinear256VideoMode (int sizeX, int sizeY)
{
  #ifndef __TURBOC__
    if ( ((sizeX > 800) || (sizeY > 600)) &&
         (SVGA_videoModeSupported (VESA_1024x768x256 + LINEAR_FRAME_BUFFER)==0))
      return VESA_1024x768x256;

    if ( ((sizeX > 640) || (sizeY > 480)) &&
         (SVGA_videoModeSupported (VESA_800x600x256 + LINEAR_FRAME_BUFFER)==0))
      return VESA_800x600x256;

    if ( ((sizeX > 640) || (sizeY > 400)) &&
         (SVGA_videoModeSupported (VESA_640x480x256 + LINEAR_FRAME_BUFFER)==0))
      return VESA_640x480x256;

    if ( ((sizeX > 320) || (sizeY > 200)) &&
         (SVGA_videoModeSupported (VESA_640x400x256 + LINEAR_FRAME_BUFFER)==0))
      return VESA_640x400x256;
  #else
    sizeY = sizeX;
    sizeX = sizeY;
  #endif

  if (SVGA_videoModeSupported (VGA_320x200x256)==0)
  {
    return VGA_320x200x256;
  }
  return 0;
}

static int SVGA_recommendScrolling256VideoMode (int sizeX, int sizeY)
{
  if ( ((sizeX > 800) || (sizeY > 600)) &&
       (SVGA_videoModeSupported (VESA_1024x768x256 | DOUBLE_BUFFER)==0))
    return VESA_1024x768x256 | DOUBLE_BUFFER;

  if ( ((sizeX > 640) || (sizeY > 480)) &&
       (SVGA_videoModeSupported (VESA_800x600x256 | DOUBLE_BUFFER)==0))
    return VESA_800x600x256 | DOUBLE_BUFFER;

  if ( ((sizeX > 640) || (sizeY > 400)) &&
       (SVGA_videoModeSupported (VESA_640x480x256 | DOUBLE_BUFFER)==0))
    return VESA_640x480x256 | DOUBLE_BUFFER;

  if ( ((sizeX > 320) || (sizeY > 240)) &&
       (SVGA_videoModeSupported (VESA_640x400x256 | DOUBLE_BUFFER)==0))
    return VESA_640x400x256 | DOUBLE_BUFFER;

//  if ( ((sizeX > 320) || (sizeY > 240)) &&
//       (SVGA_videoModeSupported (XVGA_376x282x256)==0))
//    return XVGA_376x282x256;

  if ( ((sizeX > 320) || (sizeY > 200)) &&
       (SVGA_videoModeSupported (XVGA_320x240x256 | DOUBLE_BUFFER)==0))
    return XVGA_320x240x256 | DOUBLE_BUFFER;

  if ((SVGA_videoModeSupported (XVGA_320x200x256))==0)
  {
    return XVGA_320x200x256;
  }

  return 0;
}

static int SVGA_recommend256VideoMode (int sizeX, int sizeY)
{
  if ( ((sizeX > 800) || (sizeY > 600)) &&
       (SVGA_videoModeSupported (VESA_1024x768x256)==0))
    return VESA_1024x768x256;

  if ( ((sizeX > 640) || (sizeY > 480)) &&
       (SVGA_videoModeSupported (VESA_800x600x256)==0))
    return VESA_800x600x256;

  if ( ((sizeX > 640) || (sizeY > 400)) &&
       (SVGA_videoModeSupported (VESA_640x480x256)==0))
    return VESA_640x480x256;

  if ( ((sizeX > 320) || (sizeY > 240)) &&
       (SVGA_videoModeSupported (VESA_640x400x256)==0))
    return VESA_640x400x256;

//  if ( ((sizeX > 320) || (sizeY > 240)) &&
//       (SVGA_videoModeSupported (XVGA_376x282x256)==0))
//    return XVGA_376x282x256;

  if ( ((sizeX > 320) || (sizeY > 200)) &&
       (SVGA_videoModeSupported (XVGA_320x240x256+NO_SCROLL)==0))
    return XVGA_320x240x256+NO_SCROLL;

  if ((SVGA_videoModeSupported (VGA_320x200x256)==0))
  {
    return VGA_320x200x256;
  }

  return 0;
}


int SVGA_recommendVideoMode (int sizeX, int sizeY, int bytesPerPixel, int type)
{
  switch (bytesPerPixel)
  {
    case 1:
    {
      if (type == VMODE_LINEAR)
      {
        return SVGA_recommendLinear256VideoMode (sizeX, sizeY);
      }

      if (type == VMODE_SCROLL)
      {
        return SVGA_recommendScrolling256VideoMode (sizeX, sizeY);
      }

      return SVGA_recommend256VideoMode (sizeX, sizeY);

    }
    default:
    {
      return 0;
    }
  }
}

#include "fnt8x16_.cpp"

#define BACK_CHAR 255

static char backSpace [16*8];
static char charBuf [16*8];

void SVGA_putChar (int x,int y,unsigned char c,long color)
{
  unsigned char byte;
  int  i,j,k,length;
  char *font;
  int pos;

  if (SVGA_getWin_ == B256_getWin)
  {
    if (SVGA_doubleBuffer)
    {
      SVGA_putSpr_ = B256_movSpr;
    }
    else
    {
      SVGA_putSpr_ = B256_movSpr2;
    }
  }

  if ((unsigned char)c == BACK_CHAR)
  {
    memset (backSpace, color, 16*8);
    SVGA_putSpr (backSpace, x, y, 8, 16, 8);
  }
  else
  {
    pos = 0;

    font = fnt8x16;

    for (j = 0; j < 16; j++)
    {
      byte = *(font + c * 16 + j);
      for (i = 0; i < 8; i++)
      {
        if ((byte & 0x80) != 0)
        {
          charBuf [pos] = color;
        }
        else
        {
          charBuf [pos] = 0;
        }
        pos++;
        byte <<= 1;
      }
    }
    SVGA_putSpr (charBuf, x, y, 8, 16, 8);
  }

  if (SVGA_getWin_ == B256_getWin)
  {
    SVGA_putSpr_ = B256_putSpr;
  }
}

void SVGA_putStr (int x,int y,char *str,long color)
/****************************************************************************
*
* Function:     writeText
* Parameters:   x,y     - Position to begin drawing string at
*               str     - String to draw
*
* Description:  Draws a string using the BIOS 8x16 video font by plotting
*               each pixel in the characters individually. This should
*               work for all video modes.
*
****************************************************************************/
{
  int  i,len;
  char c;
  int _x;

  _x = x;
  len = strlen(str);
  for (i = 0; i < len; i++)
  {
    c = str [i];
    switch (c)
    {
      case '\n':
      {
        y += 16;
        x = _x;
        break;
      }
      default:
      {
        SVGA_putChar (x, y, c, color);
        x += 8;
        break;
      }
    }
  }
}

void SVGA_getStr (int x, int y, char *str, long color, long backColor)
{
  char c;
  int pos;
  int phase=0;

  pos = 0;
  while (c = KEYB_get (), c != KEY_ENTER)
  {
    if (c)
    {
      SVGA_putChar (x+8*pos, y, BACK_CHAR, backColor);
    }
    switch (c)
    {
      case KEY_BACKSPACE:
      {
        if (pos > 0)
        {
          pos--;
          str [pos] = 0;
          SVGA_putChar (x+8*pos, y, BACK_CHAR, backColor);
        }
        break;
      }
      case KEY_ESC:
      {
        pos--;
        while (pos >= 0)
        {
          SVGA_putChar (x+8*pos, y, BACK_CHAR, backColor);
          pos--;
        }
        str [0] = 0;
        return;
      }
      default:
      {
        c = KEYB_ascii (c);
        if (c)
        {
          str [pos] = c;
          str [pos+1] = 0;
          SVGA_putChar (x+8*pos, y, c, color);
          pos++;
        }
        break;
      }
    }
    if (MOUSE_info.buttons.right)
    {
      while (MOUSE_info.buttons.right)
        ;
      pos--;
      while (pos >= 0)
      {
        SVGA_putChar (x+8*pos, y, BACK_CHAR,backColor);
        pos--;
      }
//      SVGA_flush ();
      str [0] = 0;
      return;
    }
    if ((phase % 20) == 10)
    {
      SVGA_putChar (x+8*pos, y, '_', color);
    }
    if ((phase % 20) == 0)
    {
      SVGA_putChar (x+8*pos, y, BACK_CHAR, backColor);
    }
//    SVGA_flush ();
    SVGA_wait (1);
//    SVGA_flush ();
    phase++;
  }
  str [pos] = 0;
}


void SVGA_virtual2RealDelta (int *dx, int *dy)
{
  int x=*dx;
  int y=*dy;

  if (x > SVGA_virtualXD2)
  {
    x += -SVGA_virtualX;
    y++;
  }
  if (x < -SVGA_virtualXD2)
  {
    x += SVGA_virtualX;
    y--;
  }
  if (y > SVGA_virtualYD2)
  {
    y -= SVGA_virtualY;
  }
  if (y < -SVGA_virtualYD2)
  {
    y += SVGA_virtualY;
  }
  *dx = x;
  *dy = y;
}

void SVGA_update (int n)
{
  MIRC_flush ();
//  if (SVGA_VESA12_mode)
//  {
//    VESA_setBank (hi (SVGA_curX + SVGA_curY * SVGA_virtualX));
//  }
  SVGA_wait (n);
  SVGAC_flush ();
}

void SVGA_flush (void)
{
  SVGA_update (0);
}

void SVGA_syncCurPos (void)
{
  SVGA_curXPrev = SVGA_curX;
  SVGA_curYPrev = SVGA_curY;

  SVGA_curX = SVGA_curXNext;
  SVGA_curY = SVGA_curYNext;

  VSB_curX = VSB_curXNext;
  VSB_curY = VSB_curYNext;
}

#define RETRACE_MAX 50

void SVGA_retraceInit (void)
{
  int i;
  double hz;

  SVGA_wait (1);
  TIMER_reset ();
  TIMER_start ();
//  TIMER_retraceTrapDisable = 1;

  for (i = 0; i < RETRACE_MAX; i++)
  {
    SVGA_wait (1);
  }

  TIMER_stop ();

  TIMER_retraceTimeMaxF = ((double) TIMER_ticks) / RETRACE_MAX;
  TIMER_retraceTimeMaxF01 = 0.1*TIMER_retraceTimeMaxF;
  TIMER_retraceTimeMaxF09 = 0.9*TIMER_retraceTimeMaxF;
  TIMER_retraceTimeMax = TIMER_ticks / RETRACE_MAX;
  hz = ((double)RETRACE_MAX * TIMER_FREQ) / TIMER_ticks;
  SVGA_freq = hz;
  SVGA_wait (1);
//  TIMER_retraceTrapDisable = 0;
  TIMER_retraceReprogram ();
  TIMER_retrace = 0;
}



#include "svgac_.cpp"
